﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.Collections;
using Com.Rscja.Deviceapi.Entity;
using Com.Rscja.Deviceapi.Exception;

namespace DemoM1
{
	[Activity (Label = "M1")]			
	public class M1 : Activity
	{
		private Spinner spTagType;
		private Spinner spKeyType;

		private Spinner spSector;
		private Spinner spBlock;
		private Button btnRead;
		private Button btnWrite;
		private TextView tvResult;

		EditText txtpwd;
		EditText txtdata;

		private ArrayAdapter adapterTagType;
		private ArrayAdapter adapterKeyType;
		private ArrayAdapter adapterSector;
		private ArrayAdapter adapterBlock;

		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);
			SetContentView (Resource.Layout.m1);
			// Create your application here
			InitView ();
		}

		void InitView()
		{
			txtpwd = FindViewById<EditText> (Resource.Id.editpassword);
			txtdata = FindViewById<EditText> (Resource.Id.editdata);
			btnRead = FindViewById<Button> (Resource.Id.btnRead);
			btnWrite = FindViewById<Button> (Resource.Id.btnWrite);
			tvResult = FindViewById<TextView> (Resource.Id.textmsg);
			spTagType=FindViewById<Spinner> (Resource.Id.sptype);
			spKeyType = FindViewById<Spinner> (Resource.Id.spkey);
			spSector = FindViewById<Spinner> (Resource.Id.spsector);
			spBlock=FindViewById<Spinner> (Resource.Id.spblock);
		
			#region spinneer设计
			//卡类型
			adapterTagType = ArrayAdapter.CreateFromResource(this,Resource.Array.arrayTagType, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			adapterTagType
				.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spTagType.Adapter = adapterTagType;
			spTagType.SetSelection (0);
			//密码
			adapterKeyType = ArrayAdapter.CreateFromResource(this,Resource.Array.arrayKeyType, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			adapterKeyType
				.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spKeyType.Adapter = adapterKeyType;
			spKeyType.SetSelection (0);
			//扇区
			adapterSector = ArrayAdapter.CreateFromResource(this,Resource.Array.arraySectorS50, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			adapterSector
				.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spSector.Adapter = adapterSector;
			spSector.SetSelection (1);
			//块
			adapterBlock = ArrayAdapter.CreateFromResource(this,Resource.Array.arrayBlockS50, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			adapterBlock
				.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spBlock.Adapter = adapterBlock;
			spBlock.SetSelection (0);

			spTagType.ItemSelected += itemtagtype;
				
			#endregion

			btnRead.Click+=new EventHandler(delegate {
				tvResult.Text="";
				if(string.IsNullOrEmpty(txtpwd.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkey, ToastLength.Long).Show();
					return;
				}
				if(txtpwd.Text.Length!=12)
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeylen, ToastLength.Long).Show();
					return;
				}
				if(!PubClass.isHexNumberRex(txtpwd.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeyhex, ToastLength.Long).Show();
					return;
				}
				tvResult.Text= Read();
			});

			btnWrite.Click += new EventHandler (delegate {
				tvResult.Text="";
				if(string.IsNullOrEmpty(txtpwd.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkey, ToastLength.Long).Show();
					return;
				}
				if(txtpwd.Text.Length!=12)
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeylen, ToastLength.Long).Show();
					return;
				}
				if(!PubClass.isHexNumberRex(txtpwd.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeyhex, ToastLength.Long).Show();
					return;
				}
				if(string.IsNullOrEmpty(txtdata.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputdata, ToastLength.Long).Show();
					return;
				}
				string data=txtdata.Text;
				if(!PubClass.isHexNumberRex(data))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeyhex, ToastLength.Long).Show();
					return;
				}
				data=data.PadRight(32,'0');
				tvResult.Text=Write(data);
			});
		}
		private void itemtagtype(object sender, AdapterView.ItemSelectedEventArgs e)
		        {
//			             Spinner spinner = (Spinner)sender;
//
//			             var toast = string.Format(spinner.GetItemAtPosition(e.Position).ToString());			 
//			             Toast.MakeText(this, toast, ToastLength.Long).Show();

		}
			
		string Read()
		{
			string msg = "";
			string cardpwd = txtpwd.Text;
			SimpleRFIDEntity rf = null;	
			Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeA;
			if (spKeyType.SelectedItemPosition == 0)
				keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeA;
			else
				keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeB;

			rf=PubClass.rfid.Request ();
			if (rf != null) {
				msg =  rf.Id+"\r\n";
				try{
				rf=PubClass.rfid.Read (cardpwd, keys,spSector.SelectedItemPosition, spBlock.SelectedItemPosition);
					return msg+rf.Data;
			} catch (Exception e) {
					// TODO Auto-generated catch block
					//e.printStackTrace();
					//Log.i("密码验证失败", e.getMessage());
					return msg + GetString (Resource.String.msgm1readexp);
				}

			} else {
				return GetString (Resource.String.msgm1getcardno);
			}
		}
	

		string Write(String data)
		{
			string msg = "";
			string cardpwd = txtpwd.Text;
			SimpleRFIDEntity rf = null;	
			Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeA;
			if (spKeyType.SelectedItemPosition == 0)
				keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeA;
			else
				keys = Com.Rscja.Deviceapi.RFIDWithISO14443A.KeyType.TypeB;

			rf=PubClass.rfid.Request ();
			if (rf != null) {
				msg =rf.Id+"\r\n";
				try{
				Boolean re=PubClass.rfid.Write(cardpwd, keys,spSector.SelectedItemPosition, spBlock.SelectedItemPosition,data);
					if (re) {
						msg +=  GetString (Resource.String.msgm1writesucc);
						return msg;
					} else
						return  msg+ GetString (Resource.String.msgm1writefial);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					//e.printStackTrace();
					//Log.i("密码验证失败", e.getMessage());
					return msg+ GetString (Resource.String.msgm1readexp);
				} 
					
			} else {
				return  GetString (Resource.String.msgm1getcardno);
			}
		}
	}
}

